import "misc.m": ProcessPresentation; 

Group6_369 := function (p: Process:=true, Select:=func<x|true>)

if p lt 5 then "6.369 is valid only for p>3"; return false; end if;

class:=4;

w:=0;
F:=FiniteField(p);
for i in [2..p-1] do
a:=F!i;
S:={a};
for j in [2..p-1] do
  Include(~S,a^j);
end for;
if #S eq p-1 then
  w:=i;
  break;
end if;
end for;
vprint Orderp7, 2:"p equals",p;
vprint Orderp7, 2:"w equals",w;

w2:=w^2 mod p;
r:=(p-1) div 2;
s:=(p+1) div 2;

L:=[]; Nmr := 0;

GR:=Group<a,b,c,d,e | c=a^p,d=(b,a,b),e=(b,a,a,b),(b,a,a,a), c^p, b^p=d*e^r>;
ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
GR:=Group<a,b,c,d,e | c=a^p,d=(b,a,b),e=(b,a,a,b),(b,a,a,a), c^p, b^p=d*e^s>;
ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
GR:=Group<a,b,c,d,e | c=a^p,d=(b,a,b),e=(b,a,a,b),(b,a,a,a), c^p=e, b^p=d*e^r>;
ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);

GR:=Group<a,b,c | c=a^p,(b,a,a,b), c^p, b^p=(b,a,b)>;
ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
GR:=Group<a,b,c,d,e | c=a^p,d=(b,a,b),e=(b,a,a,a),(b,a,a,b), c^p, b^p=d*e>;
ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
count:=5;
if p mod 3 eq 1 then
  GR:=Group<a,b,c,d,e | c=a^p,d=(b,a,b),e=(b,a,a,a),(b,a,a,b), c^p, b^p=d*e^w>;
  ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
  GR:=Group<a,b,c,d,e | c=a^p,d=(b,a,b),e=(b,a,a,a),(b,a,a,b), c^p, b^p=d*e^w2>;
  ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
  count:=7;
end if;
count:=count+1;
GR:=Group<a,b,c | c=a^p,(b,a,a,b), c^p=(b,a,a,a), b^p=(b,a,b)>;
ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);

vprint Orderp7, 1: "Group 6.369 has",count,"descendants of order p^7 and p-class 4";

vprint Orderp7, 2: "Total number of groups is 5 + gcd(p-1,3) =",
5+Gcd(p-1,3);

if Process then return Nmr; else return L; end if;

end function;
